import { HttpClient } from '@angular/common/http';
import { Injectable, ɵɵdefineInjectable, ɵɵinject, APP_INITIALIZER, isDevMode } from '@angular/core';
import { throwError } from 'rxjs';
import { SysType, QueryResult, EditResult } from '@yukawa/chain-base-angular-domain';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// import '@yukawa/chain-base-angular-domain/chaos-sys-core';
// declare const SysType;
/** @type {?} */
var TAG = 'ConfigService';
var ConfigService = /** @class */ (function () {
    function ConfigService(http) {
        this.http = http;
        /**
         * @deprecated
         */
        this.configUrl = "config.json";
        this.config = {};
    }
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @return {?}
     */
    ConfigService.prototype.initConfig = /**
     * @deprecated
     * @return {?}
     */
    function () {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            console.warn(TAG, "loadConfig is deprecated use initConfigs");
            _this.loadConfig()
                .subscribe((/**
             * @param {?} data
             * @return {?}
             */
            function (data) {
                _this.config = data;
                resolve(true);
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                console.error(TAG, "initConfig  " + error);
                //reject(error)
                return throwError(error || 'Server error');
            }));
        }));
    };
    /**
     * @param {?=} locations
     * @param {?=} rejectNotFound
     * @return {?}
     */
    ConfigService.prototype.initConfigs = /**
     * @param {?=} locations
     * @param {?=} rejectNotFound
     * @return {?}
     */
    function (locations, rejectNotFound) {
        var _this = this;
        if (locations === void 0) { locations = ['config-base.json', 'config.json']; }
        if (rejectNotFound === void 0) { rejectNotFound = false; }
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            var _loop_1 = function (idx) {
                /** @type {?} */
                var loc = locations[idx];
                _this.http.get(loc).subscribe((/**
                 * @param {?} cfg
                 * @return {?}
                 */
                function (cfg) {
                    _this.config = SysType.objectMix(_this.config || {}, cfg);
                    //this.config = this.deepCopy(this.config||{}, cfg);
                    if (idx == locations.length - 1) {
                        resolve(_this.config);
                    }
                }), (/**
                 * @param {?} error
                 * @return {?}
                 */
                function (error) {
                    if (rejectNotFound) {
                        reject(error);
                        return;
                    }
                    if (idx == locations.length - 1) {
                        resolve(_this.config);
                    }
                }));
            };
            for (var idx = 0; idx < locations.length; idx++) {
                _loop_1(idx);
            }
        }));
    };
    /**
     * @param {?=} id
     * @return {?}
     */
    ConfigService.prototype.getBaseUrl = /**
     * @param {?=} id
     * @return {?}
     */
    function (id) {
        if (id === void 0) { id = ""; }
        return id == "" ? this.config.baseUrl : this.config[id];
    };
    /**
     * @param {?} id
     * @return {?}
     */
    ConfigService.prototype.getValue = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.config[id];
    };
    /**
     * @param {?=} id
     * @return {?}
     */
    ConfigService.prototype.formatUrl = /**
     * @param {?=} id
     * @return {?}
     */
    function (id) {
        if (id === void 0) { id = "baseUrl"; }
        /** @type {?} */
        var cfg = this.config;
        if (!cfg)
            return cfg;
        cfg = cfg[id];
        if (cfg.startsWith('/') || cfg.startsWith(':'))
            cfg = this.config.baseUrl + cfg;
        return cfg;
    };
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @param {?=} id
     * @return {?}
     */
    ConfigService.prototype.getConfig = /**
     * @deprecated
     * @param {?=} id
     * @return {?}
     */
    function (id) {
        console.warn(TAG, "getConfig is deprecated use initConfigs");
        if (!id)
            return this.config;
        return "" + this.getBaseUrl() + this.config[id];
    };
    /**
     * @deprecated
     */
    /**
     * @deprecated
     * @param {?=} url
     * @return {?}
     */
    ConfigService.prototype.loadConfig = /**
     * @deprecated
     * @param {?=} url
     * @return {?}
     */
    function (url) {
        if (url === void 0) { url = 'config.json'; }
        console.warn(TAG, "loadConfig is deprecated use initConfigs " + url);
        return this.http.get(url);
    };
    ConfigService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ConfigService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ ConfigService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ConfigService_Factory() { return new ConfigService(ɵɵinject(HttpClient)); }, token: ConfigService, providedIn: "root" });
    return ConfigService;
}());
if (false) {
    /**
     * @deprecated
     * @type {?}
     * @protected
     */
    ConfigService.prototype.configUrl;
    /** @type {?} */
    ConfigService.prototype.config;
    /**
     * @type {?}
     * @protected
     */
    ConfigService.prototype.http;
}
/**
 * @param {?} config
 * @return {?}
 */
function ConfigFactory(config) {
    return (/**
     * @return {?}
     */
    function () { return config.initConfigs(); });
}
/**
 * @return {?}
 */
function init() {
    return {
        provide: APP_INITIALIZER,
        useFactory: ConfigFactory,
        deps: [ConfigService],
        multi: true
    };
}
/** @type {?} */
var ConfigModule = {
    init: init
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @Injectable({
//   providedIn: 'root'
// })
var  
// @Injectable({
//   providedIn: 'root'
// })
UrlConfigService = /** @class */ (function () {
    function UrlConfigService(cfg, configService) {
        this.cfg = cfg;
        this.configService = configService;
        console.log("xxxxxxxxxxxxx");
    }
    /**
     * @return {?}
     */
    UrlConfigService.prototype.getBackendUrl = /**
     * @return {?}
     */
    function () {
        return this.configService.formatUrl(this.cfg);
    };
    return UrlConfigService;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    UrlConfigService.prototype.cfg;
    /**
     * @type {?}
     * @protected
     */
    UrlConfigService.prototype.configService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TAG$1 = 'RestAspect';
/**
 * @abstract
 */
var  /**
 * @abstract
 */
RestAspect = /** @class */ (function () {
    function RestAspect(http, configService, serviceUrl) {
        this.http = http;
        this.configService = configService;
        this.serviceUrl = serviceUrl;
    }
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    RestAspect.prototype.formatBaseUrl = /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    function (path) {
        if (path === void 0) { path = ''; }
        return this.configService.getConfig('baseUrl') + path;
    };
    /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    RestAspect.prototype.formatServiceUrl = /**
     * @protected
     * @param {?=} path
     * @return {?}
     */
    function (path) {
        if (path === void 0) { path = ''; }
        return this.serviceUrl + path + '/';
    };
    Object.defineProperty(RestAspect.prototype, "verbose", {
        // noinspection JSMethodCanBeStatic
        get: 
        // noinspection JSMethodCanBeStatic
        /**
         * @return {?}
         */
        function () {
            return isDevMode();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?} filter
     * @param {?=} method
     * @return {?}
     */
    RestAspect.prototype.search = /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?} filter
     * @param {?=} method
     * @return {?}
     */
    function (url, filter, method) {
        if (method === void 0) { method = 'post'; }
        /** @type {?} */
        var m = method || 'post';
        if (this.verbose)
            console.debug(TAG$1, "search:", m, url, filter);
        return this.http[m](url, filter).pipe(map((/**
         * @param {?} r
         * @return {?}
         */
        function (r) {
            /** @type {?} */
            var result = (/** @type {?} */ ({
                took: (/** @type {?} */ (r.took)),
                timedOut: (/** @type {?} */ (r.timed_out)),
                rows: (/** @type {?} */ ([]))
            }));
            /** @type {?} */
            var h = r.hits;
            if (h) {
                result.total = h.total;
                for (var idx = 0; idx < h.hits.length; idx++) {
                    /** @type {?} */
                    var hit = h.hits[idx];
                    /** @type {?} */
                    var source = (/** @type {?} */ (hit._source));
                    // console.log('DeviceService', hit);
                    result.rows.push(source);
                }
            }
            return result;
        })));
    };
    /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?} filter
     * @param {?=} options
     * @return {?}
     */
    RestAspect.prototype.query = /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?} filter
     * @param {?=} options
     * @return {?}
     */
    function (url, filter, options) {
        if (options === void 0) { options = {}; }
        //options = this.defaultOptions(options);
        if (this.verbose)
            console.debug(TAG$1, "query:", url, filter);
        return this.http.post(url, filter, options).pipe(map((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return QueryResult.fromData(data); })));
    };
    /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?=} value
     * @param {?=} options
     * @return {?}
     */
    RestAspect.prototype.edit = /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?=} value
     * @param {?=} options
     * @return {?}
     */
    function (url, value, options) {
        if (value === void 0) { value = null; }
        if (options === void 0) { options = {}; }
        if (this.verbose)
            console.debug(TAG$1, "edit:", url, value);
        return (options.method === 'put'
            ? this.http.put(url, value, options)
            : this.http.post(url, value, options)).pipe(map((/**
         * @param {?} data
         * @return {?}
         */
        function (data) { return EditResult.fromData(data); })));
    };
    /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?=} value
     * @param {?=} options
     * @return {?}
     */
    RestAspect.prototype.load = /**
     * @protected
     * @template E
     * @param {?} url
     * @param {?=} value
     * @param {?=} options
     * @return {?}
     */
    function (url, value, options) {
        if (value === void 0) { value = null; }
        if (options === void 0) { options = {}; }
        if (this.verbose)
            console.debug(TAG$1, "load:", url);
        /** @type {?} */
        var method = options.method || 'get';
        /** @type {?} */
        var obs;
        if (value) {
            obs = this.http[method](url, value, options);
        }
        else {
            obs = this.http[method](url, options);
        }
        return obs;
    };
    /**
     * @protected
     * @param {?} url
     * @param {?=} filter
     * @param {?=} options
     * @return {?}
     */
    RestAspect.prototype.download = /**
     * @protected
     * @param {?} url
     * @param {?=} filter
     * @param {?=} options
     * @return {?}
     */
    function (url, filter, options) {
        if (filter === void 0) { filter = null; }
        if (options === void 0) { options = {}; }
        if (this.verbose)
            console.debug(TAG$1, "download:", url, filter);
        options = options || {};
        options.responseType = options.responseType || (/** @type {?} */ ('blob'));
        /** @type {?} */
        var method = options.method || 'post';
        return this.http[method](url, filter, options);
    };
    /**
     * @protected
     * @param {?} value
     * @param {?=} message
     * @return {?}
     */
    RestAspect.prototype.checkNotNull = /**
     * @protected
     * @param {?} value
     * @param {?=} message
     * @return {?}
     */
    function (value, message) {
        if (message === void 0) { message = "Not found"; }
        if (value == null)
            throw new Error(message);
        return value;
    };
    return RestAspect;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    RestAspect.prototype.http;
    /**
     * @type {?}
     * @protected
     */
    RestAspect.prototype.configService;
    /**
     * @type {?}
     * @protected
     */
    RestAspect.prototype.serviceUrl;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { ConfigFactory, ConfigModule, ConfigService, RestAspect, UrlConfigService, init };
//# sourceMappingURL=yukawa-chain-base-angular-client.js.map
